## mcrl2 201107.1

=== CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# Set Warning

cmake_minimum_required (VERSION 2.6)
message(STATUS "CMAKE VERSION: ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")
project (MCRL2)
# Commonly used options
# ---------------------
#
# The following lists some commonly used options to configure the build system
# (an option name following by (*) indicates the default option):
#
#   CMAKE_INSTALL_PREFIX = /usr/local(*) (any path can be used)
#   CMAKE_BUILD_TYPE     = None | Debug | Release(*) | RelwithDebInfo | MinSizeRel
#   BUILD_SHARED_LIBS    = ON    | OFF(*)
#   MCRL2_ENABLE_EXPERIMENTAL  = ON    | OFF(*)
#   MCRL2_ENABLE_DEPRECATED    = ON    | OFF(*)


# Note on adding definitions containing quotes (")
# ------------------------------------------------
#
# Compiler definitions can be added to CMake using the ADD_DEFINITIONS command
# or COMPILE_DEFINITIONS property. Be careful when adding a definition that
# contains quotes ("), as CMake cannot guarantee the generation of platform
# independent scripts. Typically these definitions are of the form FOO="bar",
# which can be added as follows:
#
#   add_definitions(-DFOO="bar")
#
# From this, CMake is able to generate correct Makefiles. However, CMake is
# not able to generate a correct Eclipse CDT4 project.
#
# The solution that is currently employed is by adding compiler definitions
# that contain quotes using the set_source_files_properties command with the
# the COMPILE_DEFINITIONS property:
#
#   set_source_files_properties(baz.cpp
#     PROPERTIES COMPILE_DEFINITIONS FOO="bar"
#   )
#
# This way, these compiler definitions are not included in the Eclipse CDT4
# project file, circumventing the problem.
#
# When this solution cannot be applied, there is another workaround: by quoting
# the entire compiling definition it is prevented from being incorporated in
# the Eclipse CDT4 project:
#
#   add_definitions(-D"FOO=\\"bar\\"")
#
# However, the best solution is to avoid the need for these quotes in the
# first place. This is mentioned as a disclaimer in the CMake 2.6 documentation
# for the COMPILER_DEFINITIONS property:
#
#   Dislaimer: Most native build tools have poor support for escaping
#   certain values. CMake has work-arounds for many cases but some values
#   may just not be possible to pass correctly. If a value does not seem to
#   be escaped correctly, do not attempt to work-around the problem by
#   adding escape sequences to the value. Your work-around may break in a
#   future version of CMake that has improved escape support. Instead
#   consider defining the macro in a (configured) header file. Then report
#   the limitation.
#
# The disclaimer with some additional information can be found here:
#
#   http://www.cmake.org/cmake/help/cmake2.6docs.html#prop_dir:COMPILE_DEFINITIONS
#

set( MCRL2_ENABLE_SVN true )
set( MCRL2_ENABLE_PARSERS true )

IF( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" STRLESS "2.8" )
  message(STATUS "=========================================" )
  message(STATUS "CMake version 2.8+ is required for:" )
  message(STATUS "  svn revision in tools" )
  message(STATUS "  generating parsers" )
  message(STATUS "Current version of CMake is NOT suitable" )
  message(STATUS "for development purposes." )
  message(STATUS "=========================================" )

	set( MCRL2_ENABLE_SVN false )
	set( MCRL2_ENABLE_PARSERS false )
ENDIF( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" STRLESS "2.8" )

# Set path where additional modules can be found
set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/scripts" ) 

# Variables required for an additional build type "Maintainer"

include(CheckCXXCompilerFlag)

if( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
  set( CXX_ACCEPTS_PROFILE_ARCS true)
  set( CXX_ACCEPTS_TEST_COVERAGE true)
else( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )
  check_cxx_compiler_flag(-fprofile-arcs CXX_ACCEPTS_PROFILE_ARCS )
  check_cxx_compiler_flag(-ftest-coverage CXX_ACCEPTS_TEST_COVERAGE )
endif( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )

set(CMAKE_CXX_FLAGS_MAINTAINER "-g -O0 -Wall -W -Wunused-variable -Wunused-parameter -Wunused-function -Wunused -Wno-system-headers -Woverloaded-virtual -Wwrite-strings" CACHE STRING "Flags used by the C++ compiler during maintainer builds.")
set(CMAKE_C_FLAGS_MAINTAINER "-g -O0 -Wall -pedantic -W" CACHE STRING "Flags used by the C compiler during maintainer builds.")
if(CXX_ACCEPTS_PROFILE_ARCS)
  set(CMAKE_CXX_FLAGS_MAINTAINER "${CMAKE_CXX_FLAGS_MAINTAINER} -fprofile-arcs")
  set(CMAKE_C_FLAGS_MAINTAINER "${CMAKE_C_FLAGS_MAINTAINER} -fprofile-arcs")
endif(CXX_ACCEPTS_PROFILE_ARCS)
if(CXX_ACCEPTS_TEST_COVERAGE)
  set(CMAKE_CXX_FLAGS_MAINTAINER "${CMAKE_CXX_FLAGS_MAINTAINER} -ftest-coverage")
  set(CMAKE_C_FLAGS_MAINTAINER "${CMAKE_C_FLAGS_MAINTAINER} -ftest-coverage")
endif(CXX_ACCEPTS_TEST_COVERAGE)

set(CMAKE_EXE_LINKER_FLAGS_MAINTAINER "-Wl,--warn-unresolved-symbols,--warn-once -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used for linking binaries during maintainer builds.")
set(CMAKE_SHARED_LINKER_FLAGS_MAINTAINER "-Wl,--warn-unresolved-symbols,--warn-once -fprofile-arcs -ftest-coverage" CACHE STRING "Flags used by the shared libraries linker during maintainer builds.")
mark_as_advanced(
  CMAKE_CXX_FLAGS_MAINTAINER
  CMAKE_C_FLAGS_MAINTAINER
  CMAKE_EXE_LINKER_FLAGS_MAINTAINER
  CMAKE_SHARED_LINKER_FLAGS_MAINTAINER
)

##---------------------------------------------------
## Print compiler information
##---------------------------------------------------

if(NOT MSVC)
execute_process(COMMAND ${CMAKE_CXX_COMPILER} --version
    OUTPUT_VARIABLE CXX_COMPILER_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

STRING(REGEX REPLACE "^([^\n]+).*" "\\1" CXX_COMPILER_VERSION "${CXX_COMPILER_VERSION}" )
else(NOT MSVC)
   set(CXX_COMPILER_VERSION "MSVC-${MSVC_VERSION}")
endif(NOT MSVC)

message(STATUS "CXX COMPILER VERSION: ${CXX_COMPILER_VERSION}")

##---------------------------------------------------
## Determine build type
##---------------------------------------------------

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)

message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE} " )

if( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )

  ##---------------------------------------------------
  ## Set global compiler flags (if available)
  ##---------------------------------------------------

  check_cxx_compiler_flag(-Wall CXX_ACCEPTS_WALL )
  if( CXX_ACCEPTS_WALL )
    add_definitions( -Wall )
  endif( CXX_ACCEPTS_WALL )

  check_cxx_compiler_flag(-Wno-inline CXX_ACCEPTS_WNO-INLINE )
  if( CXX_ACCEPTS_WNO-INLINE )
    add_definitions( -Wno-inline )
  endif( CXX_ACCEPTS_WNO-INLINE )

  if( NOT MINGW )
    check_cxx_compiler_flag(-pthread CXX_ACCEPTS_PTHREAD )
    if( CXX_ACCEPTS_PTHREAD )
      add_definitions( -pthread )
    endif( CXX_ACCEPTS_PTHREAD )
  endif( NOT MINGW )

  check_cxx_compiler_flag(-fno-strict-overflow CXX_ACCEPTS_FNO-STRICT-OVERFLOW )
  if( CXX_ACCEPTS_FNO-STRICT-OVERFLOW )
    add_definitions( -fno-strict-overflow )
  endif( CXX_ACCEPTS_FNO-STRICT-OVERFLOW )

  check_cxx_compiler_flag(-pipe CXX_ACCEPTS_PIPE )
  if( CXX_ACCEPTS_PIPE )
    add_definitions( -pipe )
  endif( CXX_ACCEPTS_PIPE )

  # Following flag will cause warning on MacOSX, if enabled:
  #686-apple-darwin9-g++-4.0.1: -as-needed: linker input file unused because linking not done
  if( NOT APPLE)
    check_cxx_compiler_flag(-Wl,-as-needed CXX_ACCEPTS_AS_NEEDED )
    if( CXX_ACCEPTS_AS_NEEDED )
      add_definitions( -Wl,-as-needed )
    endif( CXX_ACCEPTS_AS_NEEDED )
  endif( NOT APPLE )

  # Display include dependencies
  # check_cxx_compiler_flag(-H CXX_ACCEPTS_H )
  # if( CXX_ACCEPTS_H )
  #  add_definitions( -H )
  # endif( CXX_ACCEPTS_H )

  # check_cxx_compiler_flag(-Wunreachable-code CXX_ACCEPTS_UNREACHABLE-CODE )
  # if( CXX_ACCEPTS_UNREACHABLE-CODE )
  #   add_definitions( -Wunreachable-code )
  # endif( CXX_ACCEPTS_UNREACHABLE-CODE )

endif( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX )

if(MSVC)
  set (CMAKE_CXX_FLAGS "/EHs ${CMAKE_CXX_FLAGS}")
endif(MSVC)

## --------------------------------------------------
## Detect architecture
## --------------------------------------------------

if( NOT MCRL2_ARCH )
if (UNIX AND NOT WIN32)
  if (CMAKE_SIZEOF_VOID_P MATCHES "8")
    message (STATUS "Architecture: 64bit Unix" )
    set(ATERM_FLAGS "-m64 -DAT_64BIT")
    add_definitions("-DAT_64BIT")
    # set(ARCHITECTURE "x86_64")
  endif (CMAKE_SIZEOF_VOID_P MATCHES "8")
  if (CMAKE_SIZEOF_VOID_P MATCHES "4")
    message (STATUS "Architecture: 32bit Unix" )
    set(ATERM_FLAGS "-m32")
    # set(ARCHITECTURE "i386")
  endif (CMAKE_SIZEOF_VOID_P MATCHES "4")
endif (UNIX AND NOT WIN32)

if(MSVC)
  if(CMAKE_CL_64)
    message( STATUS "Architecture: 64bit Windows" )
    set (CMAKE_CXX_FLAGS "/bigobj ${CMAKE_CXX_FLAGS}")
  else(CMAKE_CL_64)
    message( STATUS "Architecture: 32bit Windows" )
  endif(CMAKE_CL_64)
endif(MSVC)
endif( NOT MCRL2_ARCH ) 

if( MCRL2_ARCH STREQUAL "i386" )
  if( UNIX )
    message( STATUS "Architecture: 32bit Unix" )
    set(ATERM_FLAGS "-m32")
		set(CMAKE_C_FLAGS "-m32 -march=i386") 
		set(CMAKE_CXX_FLAGS "-m32 -march=i386") 
  endif( UNIX )
endif( MCRL2_ARCH STREQUAL "i386" )

##---------------------------------------------------
## Remove "install_tools"
## install_tools contains the tools marked for symlink export
##---------------------------------------------------
if(APPLE)
  if(EXISTS "${CMAKE_BINARY_DIR}/install_tools" )
    FILE(REMOVE ${CMAKE_BINARY_DIR}/install_tools )
  endif(EXISTS "${CMAKE_BINARY_DIR}/install_tools" )
endif(APPLE)


##---------------------------------------------------
## Print CMake install prefix (if any)
##---------------------------------------------------

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")


##---------------------------------------------------
## Print the way how libraries are built
##---------------------------------------------------

if(MSVC)
  option(BUILD_SHARED_LIBS "Enable/disable creation of shared libraries" OFF)
else(MSVC)
  option(BUILD_SHARED_LIBS "Enable/disable creation of shared libraries" ON)
endif(MSVC)

## SET mCRL2 Library Directory
# Unix
if(UNIX)
  set(MCRL2_LIB_DIR "lib/mcrl2")
endif(UNIX)

# Override MCRL2_LIB_DIR such that libraries are stored in
# bin directory, such that they can be found after an install
if(WIN32)
  set(MCRL2_LIB_DIR "bin")
endif(WIN32)

if(APPLE AND MCRL2_SINGLE_BUNDLE)
  set(MCRL2_BIN_DIR "MacOS")
else(APPLE AND MCRL2_SINGLE_BUNDLE)
  set(MCRL2_BIN_DIR "bin")
endif(APPLE AND MCRL2_SINGLE_BUNDLE)


if(BUILD_SHARED_LIBS)
  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
    if(NOT MINGW)
      check_cxx_compiler_flag(-fPIC CXX_ACCEPTS_FPIC )
      if( CXX_ACCEPTS_FPIC )
        add_definitions( -fPIC )
        set(BUILD_SHARED_LIBS_OPTION "-fPIC")
      endif( CXX_ACCEPTS_FPIC )
    endif(NOT MINGW)
  endif( CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)

  if(CMAKE_CXX_COMPILER MATCHES "icpc" OR CMAKE_CXX_COMPILER MATCHES "clang")
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-fPIC CXX_ACCEPTS_FPIC )
    if( CXX_ACCEPTS_FPIC )
      add_definitions( -fPIC )
      set(BUILD_SHARED_LIBS_OPTION "-fPIC")
    endif( CXX_ACCEPTS_FPIC )
  endif(CMAKE_CXX_COMPILER MATCHES "icpc" OR CMAKE_CXX_COMPILER MATCHES "clang")

  if(WIN32)
    if(MINGW OR MSYS)
      get_filename_component( MINGW_LIB_DIR ${CMAKE_CXX_COMPILER} PATH )

      # Install required MINGW DLLs
      install(
	FILES
        ${MINGW_LIB_DIR}/libgcc_s_dw2-1.dll

=== 3rd-party/gl2ps/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(gl2ps)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/gl2ps/include/gl2ps)

# actual target:
add_library(${PROJECT_NAME}
  source/gl2ps.c  
)

target_link_libraries(${PROJECT_NAME}
  ${OPENGL_LIBRARY}
)

if( mlib_FOUND )
  target_link_libraries(${PROJECT_NAME}
    ${MLIB_LIBRARY}
  )
endif( mlib_FOUND )

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== doc/articles/Makefile ===
#Make rules
all     :

clean   :
	rm -f *.dvi *.log *.aux *.toc *.out *.blg *.bbl *.ps *.pdf

#LaTeX rules
%.dvi   : %.tex
	texi2dvi $^

%.ps    : %.dvi
	dvips -t a4 $^

%.pdf   : %.ps
	ps2pdf $^

%.pdf   : %.tex
	texi2dvi -p $^

=== libraries/aterm/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

project(mcrl2_aterm)
cmake_minimum_required(VERSION 2.6)

# main target
add_library(${PROJECT_NAME}
  source/idmappings.cpp
  source/bafio.cpp
  source/memmgnt.cpp
  source/memory.cpp
  source/aterm.cpp
  source/hash.cpp
  source/list.cpp
  source/afun.cpp
  source/safio.cpp
  source/byteencoding.cpp
  source/byteio.cpp
  source/gc.cpp
  source/aterm_ext.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)

install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== libraries/core/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_core)
cmake_minimum_required(VERSION 2.6)

# ######### Set policies ############

# ################################### 
# "core" links to some transitive 
# libraries for which the linker must
# search:
#   wxWidgets
# Therefore CMP0003 is set to NEW
# If not set, a BUILD_SHARED_LIB=TRUE
# combined with a wxWidgets build 
# raises a warning
# ###################################

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# ######### General setup ##########

set(mcrl2_core_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/typecheck.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/parse.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/struct_core.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/mcrl2parser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/mcrl2lexer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/regfrmtrans.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/print.cpp
)

set(mcrl2_core_src ${mcrl2_core_src} PARENT_SCOPE)

include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include )
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds/)

# actual target:
add_library(${PROJECT_NAME}
  ${mcrl2_core_src}
)

target_link_libraries(${PROJECT_NAME}
  mcrl2_aterm
  mcrl2_utilities
)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== libraries/data/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_data)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

#jitty.c requires DL_LIBS
if(UNIX)
  LINK_LIBRARIES(${CMAKE_THREAD_LIBS} ${CMAKE_DL_LIBS})
  set(COMP_REWRITERS 
   ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/jittyc.cpp
#   ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/innerc.cpp
  )
endif(UNIX)

set(mcrl2_data_src
 ${CMAKE_CURRENT_SOURCE_DIR}/source/data_specification.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/enumerate/enum_standard.cpp 
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/prover/smt_lib_solver.cpp 
 
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/with_prover.cpp
 # ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/inner.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/jitty.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/source/detail/rewrite/rewrite.cpp
 ${COMP_REWRITERS}
)

set(mcrl2_data_src ${mcrl2_data_src} PARENT_SCOPE)

include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
#The following include directory is required by out-of-source builds for finding setup.h
include_directories(${CMAKE_BINARY_DIR}/libraries/utilities/include)

add_library(${PROJECT_NAME}
  ${mcrl2_data_src}
)

target_link_libraries(${PROJECT_NAME}
  mcrl2_core
  mcrl2_utilities
)

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== libraries/lts/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(mcrl2_lts)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

include_directories(${CMAKE_SOURCE_DIR}/libraries/lts/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/trace/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/svc/include)


set(mcrl2_lts_src
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmlexer.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmlexer.h
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmlexer.ll
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmparser.h
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotparser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmparser.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotlexer.ll
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotparser.cpp
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsmparser.yy
#  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotparser.yy
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dotlexer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_aut.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_lts.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_svc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/sim_hashtable.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_dot.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_bcg.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/tree_set.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/liblts_fsm.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/exploration.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/source/lps2lts_lts.cpp
)
set(mcrl2_lts_src ${mcrl2_lts_src} PARENT_SCOPE)

# actual target:
add_library(${PROJECT_NAME}
  ${mcrl2_lts_src}
)

target_link_libraries(${PROJECT_NAME}
  mcrl2_aterm
  svc
  mcrl2_data
  mcrl2_lps
)

if( USE_BCG STREQUAL "" )
  include_directories( ${MCRL2_CADP_INCLUDE_DIR} )	
  target_link_libraries(${PROJECT_NAME}
		imp_bcg_io
    imp_bcg
  )
endif( USE_BCG STREQUAL "" )

# add install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_LIB_DIR})

=== scripts/ltsmin/CMakeLists.txt ===
# Additional install scripts
##---------------------------------------------------
## LTSMIN configure, build and install in CMAKE_INSTALL_PREFIX
##---------------------------------------------------

#Set root to source LTSmin
 set(MCRL2_LTSMIN_INSTALL_PATH ""
      CACHE PATH "Build and install the LTSmin toolset if path to the root to source is provided." )

 message( STATUS "MCRL2_LTSMIN_INSTALL_PATH: ${MCRL2_LTSMIN_INSTALL_PATH}" )

 if( NOT MCRL2_LTSMIN_INSTALL_PATH STREQUAL "" )
	 message( STATUS "Configure, build and install LTSmin toolset, after installing mCRL2" )
   configure_file( "${CMAKE_CURRENT_SOURCE_DIR}/InstallLTSmin.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/InstallLTSmin.cmake" @ONLY  )
   install( SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/InstallLTSmin.cmake" )	 
 endif( NOT MCRL2_LTSMIN_INSTALL_PATH STREQUAL "" )

=== tools/bespp/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(bespp)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

add_executable(${PROJECT_NAME}
    bespp.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/bes/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/pbes/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)

target_link_libraries(${PROJECT_NAME}
  mcrl2_data
  mcrl2_utilities
)

# install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_BIN_DIR})

# Relocate install tree
include(${CMAKE_SOURCE_DIR}/scripts/RelocateInstallTree.cmake)

# Generate man pages
include(${CMAKE_SOURCE_DIR}/scripts/GenerateManPages.cmake)

=== tools/bessolve/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(bessolve)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

add_executable(${PROJECT_NAME}
    bessolve.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/bes/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/pbes/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)

target_link_libraries(${PROJECT_NAME}
  mcrl2_data
  mcrl2_utilities
)

# install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_BIN_DIR})

# Relocate install tree
include(${CMAKE_SOURCE_DIR}/scripts/RelocateInstallTree.cmake)

# Generate man pages
include(${CMAKE_SOURCE_DIR}/scripts/GenerateManPages.cmake)

=== tools/chi2mcrl2/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(chi2mcrl2)
cmake_minimum_required(VERSION 2.6)

# ######### General setup ##########

# actual target:
add_executable(${PROJECT_NAME}
  chi2mcrl2.cpp
  chilexer.cpp
  chiparser.cpp
  translate.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)

target_link_libraries(${PROJECT_NAME} 
  mcrl2_core
  mcrl2_data
  mcrl2_utilities
)

# install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_BIN_DIR})

# Relocate install tree
include(${CMAKE_SOURCE_DIR}/scripts/RelocateInstallTree.cmake)

# Generate man pages
include(${CMAKE_SOURCE_DIR}/scripts/GenerateManPages.cmake)

=== tools/diagraphica/CMakeLists.txt ===
# Authors: Frank Stappers and Aad Mathijssen
# Copyright: see the accompanying file COPYING or copy at
# https://svn.win.tue.nl/trac/MCRL2/browser/trunk/COPYING
#
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

# ########## Project setup ##########
project(diagraphica)
cmake_minimum_required(VERSION 2.6)

if ( MCRL2_BUILD_GUI_TOOLS )

SET(MACOSX_BUNDLE_ICON_FILE diagraphica.icns)

# ######### General setup ##########

IF(WIN32)
  include_directories(${CMAKE_SOURCE_DIR}/build/msvc)
  SET(SRCS ${SRCS} diagraphica.rc)
ENDIF(WIN32)

add_executable(${PROJECT_NAME} WIN32 MACOSX_BUNDLE
  arcdiagram.cpp
  attrconti.cpp
  attrdiscr.cpp
  attribute.cpp
  bitmappanel.cpp
  bundle.cpp
  cluster.cpp
  colleague.cpp
  colorchooser.cpp
  combnplot.cpp
  corrlplot.cpp
  diagram.cpp
  diagrameditor.cpp
  diagraphica.cpp
  distrplot.cpp
  dof.cpp
  droptarget.cpp
  edge.cpp
  examiner.cpp
  frame.cpp
  glcanvas.cpp
  graph.cpp
  node.cpp
  opacitychooser.cpp
  parser.cpp
  partitionframe.cpp
  popupframe.cpp
  settingsframe.cpp
  shape.cpp
  simulator.cpp
  timeseries.cpp
  utils.cpp
  value.cpp
  visualizer.cpp
  visutils.cpp

  ${MACOSX_BUNDLE_ICON_FILE}
  ${SRCS}
)

IF (APPLE)
 SET_SOURCE_FILES_PROPERTIES(${MACOSX_BUNDLE_ICON_FILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
ENDIF (APPLE)

include_directories(${CMAKE_SOURCE_DIR}/libraries/utilities/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/core/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/data/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lps/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/lts/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/trace/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/atermpp/include)
include_directories(${CMAKE_SOURCE_DIR}/libraries/aterm/include)
include_directories(${CMAKE_SOURCE_DIR}/3rd-party/svc/include)
include_directories(${CMAKE_SOURCE_DIR}/build/precompile)
include_directories(${CMAKE_SOURCE_DIR}/build/workarounds)

target_link_libraries(${PROJECT_NAME}
  ${wxWidgets_LIBRARIES}
  mcrl2_lts
  mcrl2_utilities
  mcrl2_utilities_wx
)

# install target:
install(TARGETS ${PROJECT_NAME} DESTINATION ${MCRL2_BIN_DIR})

# Relocate install tree
include(${CMAKE_SOURCE_DIR}/scripts/RelocateInstallTree.cmake)

# Generate man pages
include(${CMAKE_SOURCE_DIR}/scripts/GenerateManPages.cmake)

endif ( MCRL2_BUILD_GUI_TOOLS )

=== debian/changelog ===
mcrl2 (201107.1-1) unstable; urgency=low

  * New upstream bugfix release:
    - Fixes infinite loop in lpsconfcheck.
  * debian/README.source: Removed, the source is no longer cleaned.
  * debian/TODO: Marked the boost-removal task as done! 
  * debian/patches/series,
    debian/patches/lintian_fixes.patch:
    - Dropped because it has been incorporated upstream.
  * debian/rules:
    - No longer set variables CMAKE_C_FLAGS_DEBUG, MCRL2_BUILD_IN_SOURCE,
      and MCRL2_USE_BOOST_INTERNAL as they are no longer used by the
      project. 
  * debian/watch: Updated to also track bugfix releases.

 -- Paul van Tilburg <paulvt@debian.org>  Thu, 20 Oct 2011 15:28:23 +0200

=== debian/control ===
Source: mcrl2
Section: math
Priority: extra
Maintainer: Paul van Tilburg <paulvt@debian.org>
Build-Depends: debhelper (>= 5), cmake, libboost-filesystem-dev (>= 1.37), libboost-regex-dev (>= 1.37), libboost-signals-dev (>= 1.37), libboost-system-dev (>= 1.37), libboost-serialization-dev (>= 1.37), libwxgtk2.8-dev (>= 2.8.4), libglu1-mesa-dev (>= 7.0.1), libgl2ps-dev
Standards-Version: 3.9.2
Homepage: http://www.mcrl2.org/
Vcs-Browser: https://svn.win.tue.nl/viewcvs/MCRL2/packaging/mcrl2/trunk/
Vcs-Svn: https://svn.win.tue.nl/repos/MCRL2/packaging/mcrl2/trunk/

Package: mcrl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: formal specification language toolset
 mCRL2 stands for micro Common Representation Language 2.  It is a
 specification language that can be used to specify and analyse the
 behaviour of distributed systems and protocols and is the successor to
 muCRL.  Using its accompanying toolset, systems can be analysed and
 verified automatically.
 .
 This toolset supports a collection of tools for linearisation, simulation,
 state-space exploration and generation and tools to optimise and analyse
 specifications.  Moreover, state spaces can be manipulated, visualised and
 analysed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Makefile to build the mCRL2 package using debhelper.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS_RELEASE = -O0 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O0 -g $(CFLAGS)
else 
	CFLAGS_RELEASE = -O2 -g -DNDEBUG $(CFLAGS)
	CFLAGS_DEBUG   = -O2 -g $(CFLAGS)
endif

BUILD_TYPE = Release
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	BUILD_TYPE = Debug
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))  
    MAKEFLAGS += -j$(NUMJOBS)
endif

BUILD_FLAGS = -DCMAKE_INSTALL_PREFIX="/usr" \
              -DCMAKE_INSTALL_RPATH="/usr/lib/mcrl2" \
	      -DCMAKE_BUILD_TYPE="$(BUILD_TYPE)" \
	      -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS_RELEASE)" \
	      -DCMAKE_VERBOSE_MAKEFILE="ON" \
	      -DMCRL2_ENABLE_EXPERIMENTAL="OFF" \
	      -DMCRL2_ENABLE_DEPRECATED="OFF"	 \
	      -DMCRL2_ENABLE_TEST_TARGETS="OFF" \
	      -DMCRL2_MAN_PAGES="ON"
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	BUILD_FLAGS += -DCMAKE_SYSTEM_NAME=$(shell dpkg-architecture -qDEB_BUILD_ARCH_OS) \
		       -DCMAKE_SYSTEM_PROCESSOR=$(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU) \
		       -DCMAKE_C_COMPILER=$(DEB_BUILD_GNU_TYPE)-gcc
endif

SRC	:= $(CURDIR)
BUILD	:= $(CURDIR)/debian/build
TARGET	:= $(CURDIR)/debian/mcrl2

configure: configure-stamp

configure-stamp:
	dh_testdir
	[ -d $(BUILD) ] || mkdir $(BUILD)
	cd $(BUILD) && \
	  cmake $(BUILD_FLAGS) $(CURDIR) 
	touch $@

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp: configure
	dh_testdir
	$(MAKE) -C $(BUILD) $(MAKEFLAGS)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -rf $(BUILD)
	rm -f configure-stamp build-stamp 
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs
	$(MAKE) -C $(BUILD) install DESTDIR=$(TARGET)
	# Generate and install the man pages.
	export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$(BUILD)/usr/lib/mcrl2
	$(MAKE) -C $(BUILD) $(MAKEFLAGS)
	$(MAKE) -C $(BUILD) install DESTDIR=$(TARGET)

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -V --exclude=/usr/lib/mcrl2
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build build-arch build-indexp clean binary-indep binary-arch binary install

=== debian/watch ===
# mCRL2 watch file

version=3
http://mcrl2.org/mcrl2/wiki/index.php/Download .*mcrl2-([\d\.]+)-src\.tar\.gz.*
